diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index c5f6593..1789f0b 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -117,7 +117,7 @@ double		parallel_setup_cost = DEFAULT_PARALLEL_SETUP_COST;
 
 int			effective_cache_size = DEFAULT_EFFECTIVE_CACHE_SIZE;
 
-Cost		disable_cost = 1.0e10;
+double		disable_cost = 1.0e10;
 
 int			max_parallel_workers_per_gather = 2;
 
@@ -171,7 +171,7 @@ static Selectivity get_foreign_key_join_selectivity(PlannerInfo *root,
 													Relids inner_relids,
 													SpecialJoinInfo *sjinfo,
 													List **restrictlist);
-static Cost append_nonpartial_cost(List *subpaths, int numpaths,
+static Cost *append_nonpartial_cost(List *subpaths, int numpaths,
 								   int parallel_workers);
 static void set_rel_width(PlannerInfo *root, RelOptInfo *rel);
 static double relation_byte_size(double tuples, int width);
@@ -211,7 +211,7 @@ void
 cost_seqscan(Path *path, PlannerInfo *root,
 			 RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
+	Cost		startup_cost = {0};
 	Cost		cpu_run_cost;
 	Cost		disk_run_cost;
 	double		spc_seq_page_cost;
@@ -229,7 +229,7 @@ cost_seqscan(Path *path, PlannerInfo *root,
 		path->rows = baserel->rows;
 
 	if (!enable_seqscan)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/* fetch estimated page cost for tablespace containing table */
 	get_tablespace_page_costs(baserel->reltablespace,
@@ -239,17 +239,18 @@ cost_seqscan(Path *path, PlannerInfo *root,
 	/*
 	 * disk costs
 	 */
-	disk_run_cost = spc_seq_page_cost * baserel->pages;
+	cost_set_member_mul_spc(&disk_run_cost, spc_, seq_page_cost, baserel->pages);
 
 	/* CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	cpu_run_cost = cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cpu_run_cost = cpu_per_tuple;
+	cost_mul_scalar(&cpu_run_cost, baserel->tuples);
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	cpu_run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&cpu_run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	/* Adjust costing for parallelism, if used. */
 	if (path->parallel_workers > 0)
@@ -257,7 +258,7 @@ cost_seqscan(Path *path, PlannerInfo *root,
 		double		parallel_divisor = get_parallel_divisor(path);
 
 		/* The CPU cost is divided among all the workers. */
-		cpu_run_cost /= parallel_divisor;
+		cost_mul_scalar(&cpu_run_cost, 1.0/parallel_divisor);
 
 		/*
 		 * It may be possible to amortize some of the I/O cost, but probably
@@ -274,7 +275,7 @@ cost_seqscan(Path *path, PlannerInfo *root,
 	}
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + cpu_run_cost + disk_run_cost;
+	cost_set_sum3(&path->total_cost, &startup_cost, &cpu_run_cost, &disk_run_cost);
 }
 
 /*
@@ -288,14 +289,13 @@ void
 cost_samplescan(Path *path, PlannerInfo *root,
 				RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	RangeTblEntry *rte;
 	TableSampleClause *tsc;
 	TsmRoutine *tsm;
 	double		spc_seq_page_cost,
-				spc_random_page_cost,
-				spc_page_cost;
+				spc_random_page_cost;
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 
@@ -319,14 +319,16 @@ cost_samplescan(Path *path, PlannerInfo *root,
 							  &spc_seq_page_cost);
 
 	/* if NextSampleBlock is used, assume random access, else sequential */
-	spc_page_cost = (tsm->NextSampleBlock != NULL) ?
-		spc_random_page_cost : spc_seq_page_cost;
 
 	/*
 	 * disk costs (recall that baserel->pages has already been set to the
 	 * number of pages the sampling method will visit)
 	 */
-	run_cost += spc_page_cost * baserel->pages;
+
+	if (tsm->NextSampleBlock != NULL)
+		cost_add_member_mul(&run_cost, random_page_cost, baserel->pages);
+	else
+		cost_add_member_mul(&run_cost, seq_page_cost, baserel->pages);
 
 	/*
 	 * CPU costs (recall that baserel->tuples has already been set to the
@@ -338,15 +340,15 @@ cost_samplescan(Path *path, PlannerInfo *root,
 	 */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -364,8 +366,8 @@ cost_gather(GatherPath *path, PlannerInfo *root,
 			RelOptInfo *rel, ParamPathInfo *param_info,
 			double *rows)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 
 	/* Mark the path with the correct row estimate */
 	if (rows)
@@ -377,14 +379,14 @@ cost_gather(GatherPath *path, PlannerInfo *root,
 
 	startup_cost = path->subpath->startup_cost;
 
-	run_cost = path->subpath->total_cost - path->subpath->startup_cost;
+	cost_set_diff(&run_cost, &path->subpath->total_cost, &path->subpath->startup_cost);
 
 	/* Parallel setup and communication cost. */
-	startup_cost += parallel_setup_cost;
-	run_cost += parallel_tuple_cost * path->path.rows;
+	cost_add_member(&startup_cost, parallel_setup_cost);
+	cost_add_member_mul(&run_cost, parallel_tuple_cost, path->path.rows);
 
 	path->path.startup_cost = startup_cost;
-	path->path.total_cost = (startup_cost + run_cost);
+	cost_set_sum2(&path->path.total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -403,8 +405,8 @@ cost_gather_merge(GatherMergePath *path, PlannerInfo *root,
 				  Cost input_startup_cost, Cost input_total_cost,
 				  double *rows)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	Cost		comparison_cost;
 	double		N;
 	double		logN;
@@ -418,7 +420,7 @@ cost_gather_merge(GatherMergePath *path, PlannerInfo *root,
 		path->path.rows = rel->rows;
 
 	if (!enable_gathermerge)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/*
 	 * Add one to the number of workers to account for the leader.  This might
@@ -430,16 +432,16 @@ cost_gather_merge(GatherMergePath *path, PlannerInfo *root,
 	logN = LOG2(N);
 
 	/* Assumed cost per tuple comparison */
-	comparison_cost = 2.0 * cpu_operator_cost;
+	cost_set_member_mul(&comparison_cost, cpu_operator_cost, 2.0);
 
 	/* Heap creation cost */
-	startup_cost += comparison_cost * N * logN;
+	cost_add_mul(&startup_cost, &comparison_cost, N * logN);
 
 	/* Per-tuple heap maintenance cost */
-	run_cost += path->path.rows * comparison_cost * logN;
+	cost_add_mul(&run_cost, &comparison_cost, path->path.rows * logN);
 
 	/* small cost for heap management, like cost_merge_append */
-	run_cost += cpu_operator_cost * path->path.rows;
+	cost_add_member_mul(&run_cost, cpu_operator_cost, path->path.rows);
 
 	/*
 	 * Parallel setup and communication cost.  Since Gather Merge, unlike
@@ -447,11 +449,11 @@ cost_gather_merge(GatherMergePath *path, PlannerInfo *root,
 	 * worker, we bump the IPC cost up a little bit as compared with Gather.
 	 * For lack of a better idea, charge an extra 5%.
 	 */
-	startup_cost += parallel_setup_cost;
-	run_cost += parallel_tuple_cost * path->path.rows * 1.05;
+	cost_add_member(&startup_cost, parallel_setup_cost);
+	cost_add_member_mul(&run_cost, parallel_tuple_cost, path->path.rows * 1.05);
 
-	path->path.startup_cost = startup_cost + input_startup_cost;
-	path->path.total_cost = (startup_cost + run_cost + input_total_cost);
+	cost_set_sum2(&path->path.startup_cost, &startup_cost, &input_startup_cost);
+	cost_set_sum3(&path->path.total_cost, &startup_cost, &run_cost, &input_total_cost);
 }
 
 /*
@@ -481,9 +483,9 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 	bool		indexonly = (path->path.pathtype == T_IndexOnlyScan);
 	amcostestimate_function amcostestimate;
 	List	   *qpquals;
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
-	Cost		cpu_run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
+	Cost		cpu_run_cost = {0};
 	Cost		indexStartupCost;
 	Cost		indexTotalCost;
 	Selectivity indexSelectivity;
@@ -531,7 +533,7 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 	}
 
 	if (!enable_indexscan)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 	/* we don't need to check enable_indexonlyscan; indxpath.c does that */
 
 	/*
@@ -556,8 +558,9 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 	path->indexselectivity = indexSelectivity;
 
 	/* all costs for touching index itself included here */
-	startup_cost += indexStartupCost;
-	run_cost += indexTotalCost - indexStartupCost;
+	cost_add(&startup_cost, &indexStartupCost);
+	cost_add(&run_cost, &indexTotalCost);
+	cost_sub(&run_cost, &indexStartupCost);
 
 	/* estimate number of main-table tuples fetched */
 	tuples_fetched = clamp_row_est(indexSelectivity * baserel->tuples);
@@ -614,7 +617,7 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 
 		rand_heap_pages = pages_fetched;
 
-		max_IO_cost = (pages_fetched * spc_random_page_cost) / loop_count;
+		cost_set_member_mul_spc(&max_IO_cost, spc_, random_page_cost, pages_fetched / loop_count);
 
 		/*
 		 * In the perfectly correlated case, the number of pages touched by
@@ -636,7 +639,7 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 		if (indexonly)
 			pages_fetched = ceil(pages_fetched * (1.0 - baserel->allvisfrac));
 
-		min_IO_cost = (pages_fetched * spc_random_page_cost) / loop_count;
+		cost_set_member_mul_spc(&min_IO_cost, spc_, seq_page_cost, pages_fetched / loop_count);
 	}
 	else
 	{
@@ -655,7 +658,7 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 		rand_heap_pages = pages_fetched;
 
 		/* max_IO_cost is for the perfectly uncorrelated case (csquared=0) */
-		max_IO_cost = pages_fetched * spc_random_page_cost;
+		cost_set_member_mul_spc(&max_IO_cost, spc_, random_page_cost, pages_fetched);
 
 		/* min_IO_cost is for the perfectly correlated case (csquared=1) */
 		pages_fetched = ceil(indexSelectivity * (double) baserel->pages);
@@ -665,12 +668,12 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 
 		if (pages_fetched > 0)
 		{
-			min_IO_cost = spc_random_page_cost;
+			cost_set_member_mul_spc(&min_IO_cost, spc_, random_page_cost, 1.0);
 			if (pages_fetched > 1)
-				min_IO_cost += (pages_fetched - 1) * spc_seq_page_cost;
+				cost_set_member_mul_spc(&min_IO_cost, spc_, seq_page_cost, pages_fetched - 1);
 		}
 		else
-			min_IO_cost = 0;
+			cost_zero(&min_IO_cost);
 	}
 
 	if (partial_path)
@@ -711,7 +714,10 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 	 */
 	csquared = indexCorrelation * indexCorrelation;
 
-	run_cost += max_IO_cost + csquared * (min_IO_cost - max_IO_cost);
+	cost_add(&run_cost, &max_IO_cost);
+	cost_sub(&min_IO_cost, &max_IO_cost);
+	cost_mul_scalar(&min_IO_cost, csquared);
+	cost_add(&run_cost, &min_IO_cost);
 
 	/*
 	 * Estimate CPU costs per tuple.
@@ -721,14 +727,14 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 	 */
 	cost_qual_eval(&qpqual_cost, qpquals, root);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
 
-	cpu_run_cost += cpu_per_tuple * tuples_fetched;
+	cost_add_mul(&cpu_run_cost, &cpu_per_tuple, tuples_fetched);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->path.pathtarget->cost.startup;
-	cpu_run_cost += path->path.pathtarget->cost.per_tuple * path->path.rows;
+	cost_add(&startup_cost, &path->path.pathtarget->cost.startup);
+	cost_add_mul(&cpu_run_cost, &path->path.pathtarget->cost.per_tuple, path->path.rows);
 
 	/* Adjust costing for parallelism, if used. */
 	if (path->path.parallel_workers > 0)
@@ -738,13 +744,13 @@ cost_index(IndexPath *path, PlannerInfo *root, double loop_count,
 		path->path.rows = clamp_row_est(path->path.rows / parallel_divisor);
 
 		/* The CPU cost is divided among all the workers. */
-		cpu_run_cost /= parallel_divisor;
+		cost_mul_scalar(&cpu_run_cost, 1.0/parallel_divisor);
 	}
 
-	run_cost += cpu_run_cost;
+	cost_add(&run_cost, &cpu_run_cost);
 
 	path->path.startup_cost = startup_cost;
-	path->path.total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->path.total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -941,8 +947,8 @@ cost_bitmap_heap_scan(Path *path, PlannerInfo *root, RelOptInfo *baserel,
 					  ParamPathInfo *param_info,
 					  Path *bitmapqual, double loop_count)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	Cost		indexTotalCost;
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
@@ -966,13 +972,13 @@ cost_bitmap_heap_scan(Path *path, PlannerInfo *root, RelOptInfo *baserel,
 		path->rows = baserel->rows;
 
 	if (!enable_bitmapscan)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	pages_fetched = compute_bitmap_pages(root, baserel, bitmapqual,
 										 loop_count, &indexTotalCost,
 										 &tuples_fetched);
 
-	startup_cost += indexTotalCost;
+	cost_add(&startup_cost, &indexTotalCost);
 	T = (baserel->pages > 1) ? (double) baserel->pages : 1.0;
 
 	/* Fetch estimated page costs for tablespace containing table. */
@@ -987,14 +993,15 @@ cost_bitmap_heap_scan(Path *path, PlannerInfo *root, RelOptInfo *baserel,
 	 * nonlinear, too. For lack of a better idea, interpolate like this to
 	 * determine the cost per page.
 	 */
-	if (pages_fetched >= 2.0)
-		cost_per_page = spc_random_page_cost -
-			(spc_random_page_cost - spc_seq_page_cost)
-			* sqrt(pages_fetched / T);
-	else
-		cost_per_page = spc_random_page_cost;
+	if (pages_fetched >= 2.0) {
+		cost_set_member_mul_spc(&cost_per_page, spc_, random_page_cost,
+				1-sqrt(pages_fetched/T));
+
+		cost_set_member_mul_spc(&cost_per_page, spc_, seq_page_cost, sqrt(pages_fetched/T));
+	} else
+		cost_set_member_mul_spc(&cost_per_page, spc_, random_page_cost, 1.0);
 
-	run_cost += pages_fetched * cost_per_page;
+	cost_add_mul(&run_cost, &cost_per_page, pages_fetched);
 
 	/*
 	 * Estimate CPU costs per tuple.
@@ -1007,9 +1014,9 @@ cost_bitmap_heap_scan(Path *path, PlannerInfo *root, RelOptInfo *baserel,
 	 */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	cpu_run_cost = cpu_per_tuple * tuples_fetched;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&cpu_run_cost, &cpu_per_tuple, tuples_fetched);
 
 	/* Adjust costing for parallelism, if used. */
 	if (path->parallel_workers > 0)
@@ -1017,20 +1024,20 @@ cost_bitmap_heap_scan(Path *path, PlannerInfo *root, RelOptInfo *baserel,
 		double		parallel_divisor = get_parallel_divisor(path);
 
 		/* The CPU cost is divided among all the workers. */
-		cpu_run_cost /= parallel_divisor;
+		cost_mul_scalar(&cpu_run_cost, 1.0/parallel_divisor);
 
 		path->rows = clamp_row_est(path->rows / parallel_divisor);
 	}
 
 
-	run_cost += cpu_run_cost;
+	cost_add(&run_cost, &cpu_run_cost);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1051,7 +1058,7 @@ cost_bitmap_tree_node(Path *path, Cost *cost, Selectivity *selec)
 		 * scan doesn't look to be the same cost as an indexscan to retrieve a
 		 * single tuple.
 		 */
-		*cost += 0.1 * cpu_operator_cost * path->rows;
+		cost_add_member_mul(cost, cpu_operator_cost, 0.1 * path->rows);
 	}
 	else if (IsA(path, BitmapAndPath))
 	{
@@ -1066,7 +1073,8 @@ cost_bitmap_tree_node(Path *path, Cost *cost, Selectivity *selec)
 	else
 	{
 		elog(ERROR, "unrecognized node type: %d", nodeTag(path));
-		*cost = *selec = 0;		/* keep compiler quiet */
+		*selec = 0;		/* keep compiler quiet */
+		cost_zero(cost);
 	}
 }
 
@@ -1083,7 +1091,7 @@ cost_bitmap_tree_node(Path *path, Cost *cost, Selectivity *selec)
 void
 cost_bitmap_and_node(BitmapAndPath *path, PlannerInfo *root)
 {
-	Cost		totalCost;
+	Cost		totalCost = {0};
 	Selectivity selec;
 	ListCell   *l;
 
@@ -1096,7 +1104,6 @@ cost_bitmap_and_node(BitmapAndPath *path, PlannerInfo *root)
 	 * cpu_operator_cost for each tbm_intersect needed.  Probably too small,
 	 * definitely too simplistic?
 	 */
-	totalCost = 0.0;
 	selec = 1.0;
 	foreach(l, path->bitmapquals)
 	{
@@ -1108,9 +1115,9 @@ cost_bitmap_and_node(BitmapAndPath *path, PlannerInfo *root)
 
 		selec *= subselec;
 
-		totalCost += subCost;
+		cost_add(&totalCost, &subCost);
 		if (l != list_head(path->bitmapquals))
-			totalCost += 100.0 * cpu_operator_cost;
+			cost_add_member_mul(&totalCost, cpu_operator_cost, 100.0);
 	}
 	path->bitmapselectivity = selec;
 	path->path.rows = 0;		/* per above, not used */
@@ -1127,7 +1134,7 @@ cost_bitmap_and_node(BitmapAndPath *path, PlannerInfo *root)
 void
 cost_bitmap_or_node(BitmapOrPath *path, PlannerInfo *root)
 {
-	Cost		totalCost;
+	Cost		totalCost = {0};
 	Selectivity selec;
 	ListCell   *l;
 
@@ -1141,7 +1148,6 @@ cost_bitmap_or_node(BitmapOrPath *path, PlannerInfo *root)
 	 * definitely too simplistic?  We are aware that the tbm_unions are
 	 * optimized out when the inputs are BitmapIndexScans.
 	 */
-	totalCost = 0.0;
 	selec = 0.0;
 	foreach(l, path->bitmapquals)
 	{
@@ -1153,10 +1159,10 @@ cost_bitmap_or_node(BitmapOrPath *path, PlannerInfo *root)
 
 		selec += subselec;
 
-		totalCost += subCost;
+		cost_add(&totalCost, &subCost);
 		if (l != list_head(path->bitmapquals) &&
 			!IsA(subpath, IndexPath))
-			totalCost += 100.0 * cpu_operator_cost;
+			cost_add_member_mul(&totalCost, cpu_operator_cost, 100.0);
 	}
 	path->bitmapselectivity = Min(selec, 1.0);
 	path->path.rows = 0;		/* per above, not used */
@@ -1176,8 +1182,8 @@ void
 cost_tidscan(Path *path, PlannerInfo *root,
 			 RelOptInfo *baserel, List *tidquals, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	bool		isCurrentOf = false;
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
@@ -1234,11 +1240,12 @@ cost_tidscan(Path *path, PlannerInfo *root,
 	 */
 	if (isCurrentOf)
 	{
-		Assert(baserel->baserestrictcost.startup >= disable_cost);
-		startup_cost -= disable_cost;
+		// Assert(cost_asscalar(&baserel->baserestrictcost.startup) >= disable_cost);
+		Assert(&baserel->baserestrictcost.startup.disable_cost!=0);
+		cost_add_member_mul(&startup_cost, disable_cost, -1);
 	}
 	else if (!enable_tidscan)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/*
 	 * The TID qual expressions will be computed once, any other baserestrict
@@ -1252,23 +1259,23 @@ cost_tidscan(Path *path, PlannerInfo *root,
 							  NULL);
 
 	/* disk costs --- assume each tuple on a different page */
-	run_cost += spc_random_page_cost * ntuples;
+	cost_add_member_mul_spc(&run_cost, spc_, random_page_cost, ntuples);
 
 	/* Add scanning CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
 	/* XXX currently we assume TID quals are a subset of qpquals */
-	startup_cost += qpqual_cost.startup + tid_qual_cost.per_tuple;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple -
-		tid_qual_cost.per_tuple;
-	run_cost += cpu_per_tuple * ntuples;
+	cost_add2(&startup_cost, &qpqual_cost.startup, &tid_qual_cost.per_tuple);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_sub(&cpu_per_tuple, &tid_qual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, ntuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1309,15 +1316,16 @@ cost_subqueryscan(SubqueryScanPath *path, PlannerInfo *root,
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
 	startup_cost = qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost = cpu_per_tuple * baserel->tuples;
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	run_cost = cpu_per_tuple;
+	cost_mul_scalar(&run_cost, baserel->tuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->path.pathtarget->cost.startup;
-	run_cost += path->path.pathtarget->cost.per_tuple * path->path.rows;
+	cost_add(&startup_cost, &path->path.pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->path.pathtarget->cost.per_tuple, path->path.rows);
 
-	path->path.startup_cost += startup_cost;
-	path->path.total_cost += startup_cost + run_cost;
+	cost_add(&path->path.startup_cost, &startup_cost);
+	cost_add2(&path->path.total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1331,8 +1339,8 @@ void
 cost_functionscan(Path *path, PlannerInfo *root,
 				  RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 	RangeTblEntry *rte;
@@ -1364,21 +1372,21 @@ cost_functionscan(Path *path, PlannerInfo *root,
 	 */
 	cost_qual_eval_node(&exprcost, (Node *) rte->functions, root);
 
-	startup_cost += exprcost.startup + exprcost.per_tuple;
+	cost_add2(&startup_cost, &exprcost.startup, &exprcost.per_tuple);
 
 	/* Add scanning CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1392,8 +1400,8 @@ void
 cost_tablefuncscan(Path *path, PlannerInfo *root,
 				   RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 	RangeTblEntry *rte;
@@ -1420,21 +1428,21 @@ cost_tablefuncscan(Path *path, PlannerInfo *root,
 	 */
 	cost_qual_eval_node(&exprcost, (Node *) rte->tablefunc, root);
 
-	startup_cost += exprcost.startup + exprcost.per_tuple;
+	cost_add2(&startup_cost, &exprcost.startup, &exprcost.per_tuple);
 
 	/* Add scanning CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1448,8 +1456,8 @@ void
 cost_valuesscan(Path *path, PlannerInfo *root,
 				RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 
@@ -1467,21 +1475,22 @@ cost_valuesscan(Path *path, PlannerInfo *root,
 	 * For now, estimate list evaluation cost at one operator eval per list
 	 * (probably pretty bogus, but is it worth being smarter?)
 	 */
-	cpu_per_tuple = cpu_operator_cost;
+	cost_set_member(&cpu_per_tuple, cpu_operator_cost);
 
 	/* Add scanning CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple += cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_add_member(&cpu_per_tuple, cpu_tuple_cost);
+	cost_add(&cpu_per_tuple, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1498,8 +1507,8 @@ void
 cost_ctescan(Path *path, PlannerInfo *root,
 			 RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 
@@ -1514,21 +1523,21 @@ cost_ctescan(Path *path, PlannerInfo *root,
 		path->rows = baserel->rows;
 
 	/* Charge one CPU tuple cost per row for tuplestore manipulation */
-	cpu_per_tuple = cpu_tuple_cost;
+	cost_set_member(&cpu_per_tuple, cpu_tuple_cost);
 
 	/* Add scanning CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple += cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->pathtarget->cost.startup;
-	run_cost += path->pathtarget->cost.per_tuple * path->rows;
+	cost_add(&startup_cost, &path->pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->pathtarget->cost.per_tuple, path->rows);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1539,8 +1548,8 @@ void
 cost_namedtuplestorescan(Path *path, PlannerInfo *root,
 						 RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 
@@ -1555,17 +1564,17 @@ cost_namedtuplestorescan(Path *path, PlannerInfo *root,
 		path->rows = baserel->rows;
 
 	/* Charge one CPU tuple cost per row for tuplestore manipulation */
-	cpu_per_tuple = cpu_tuple_cost;
+	cost_set_member(&cpu_per_tuple, cpu_tuple_cost);
 
 	/* Add scanning CPU costs */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple += cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1576,8 +1585,8 @@ void
 cost_resultscan(Path *path, PlannerInfo *root,
 				RelOptInfo *baserel, ParamPathInfo *param_info)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	QualCost	qpqual_cost;
 	Cost		cpu_per_tuple;
 
@@ -1594,12 +1603,12 @@ cost_resultscan(Path *path, PlannerInfo *root,
 	/* We charge qual cost plus cpu_tuple_cost */
 	get_restriction_qual_cost(root, baserel, param_info, &qpqual_cost);
 
-	startup_cost += qpqual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qpqual_cost.per_tuple;
-	run_cost += cpu_per_tuple * baserel->tuples;
+	cost_add(&startup_cost, &qpqual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qpqual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, baserel->tuples);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1627,7 +1636,7 @@ cost_recursive_union(Path *runion, Path *nrterm, Path *rterm)
 	 * size of each one of them.  These are mighty shaky assumptions but it's
 	 * hard to see how to do better.
 	 */
-	total_cost += 10 * rterm->total_cost;
+	cost_add_mul(&total_cost, &rterm->total_cost, 10);
 	total_rows += 10 * rterm->rows;
 
 	/*
@@ -1635,7 +1644,7 @@ cost_recursive_union(Path *runion, Path *nrterm, Path *rterm)
 	 * manipulating the tuplestores.  (We don't worry about possible
 	 * spill-to-disk costs.)
 	 */
-	total_cost += cpu_tuple_cost * total_rows;
+	cost_add_member_mul(&total_cost, cpu_tuple_cost, total_rows);
 
 	runion->startup_cost = startup_cost;
 	runion->total_cost = total_cost;
